/*!
 * @file        main.c
 *
 * @brief       Main program body
 *
 * @version     V1.0.0
 *
 * @date        2025-01-01
 *
 * @attention
 *
 *  Copyright (C) 2025 Geehy Semiconductor
 *
 *  You may not use this file except in compliance with the
 *  GEEHY COPYRIGHT NOTICE (GEEHY SOFTWARE PACKAGE LICENSE).
 *
 *  The program is only for reference, which is distributed in the hope
 *  that it will be useful and instructional for customers to develop
 *  their software. Unless required by applicable law or agreed to in
 *  writing, the program is distributed on an "AS IS" BASIS, WITHOUT
 *  ANY WARRANTY OR CONDITIONS OF ANY KIND, either express or implied.
 *  See the GEEHY SOFTWARE PACKAGE LICENSE for the governing permissions
 *  and limitations under the License.
 */

/* Includes ***************************************************************/
#include "main.h"
#include <stdio.h>
#include "bmp561_wwdt.h"
#include "bmp561_sysctrl.h"
#include "bmp561_gpio.h"
#include "bmp561_misc.h"

/* Private includes *******************************************************/

/* Private macro **********************************************************/

/* Private typedef ********************************************************/

/* Private variables ******************************************************/
volatile uint32_t feeddogTime = 0;

/* Private function prototypes ********************************************/
void WWDT_Init(void);
void GPIO_Init(void);

/* External variables *****************************************************/

/* External functions *****************************************************/

/*!
 * @brief   Main program
 *
 * @param   None
 *
 * @retval  None
 */
int main(void)
{
    GPIO_Init();

    if (SYSCTRL_ReadResetFlag(SYSCTRL_RST_WWDT) == SET)
    {
        GPIO_SetBit(GPIO_PIN_4);
        SYSCTRL_ClearResetFlag(SYSCTRL_RST_WWDT);
    }

    WWDT_Init();

    while (1)
    {
    }
}

/*!
 * @brief   WWDT initialization
 *
 * @param   None
 *
 * @retval  None
 */
void WWDT_Init(void)
{
    SYSCTRL_Unlock();
    SYSCTRL_EnableAPBPeriphBCGClock(SYSCTRL_APB_WWDT);
    SYSCTRL_EnableAPBPeriphWCGClock(SYSCTRL_APB_WWDT);
    SYSCTRL_Lock();

    /* WWDT prescaler = 256, freq = 4MHz / 256 = 15625 */
    WWDT_ConfigPrescaler(WWDT_PS_8);

    WWDT_SetWindowValue(0x3FFF);

    WWDT_EnableInterrupt();
    NVIC_EnableIRQRequest(WWDT_IRQn, 0xF);
    WWDT_ClearIntFlag();

    /* Enable WWDT */
    WWDT_FeedDog();
}

/*!
 * @brief   GPIO initialization
 *
 * @param   None
 *
 * @retval  None
 */
void GPIO_Init(void)
{
    SYSCTRL_Unlock();
    SYSCTRL_EnableAHBPeriphClock(SYSCTRL_AHB_GPIO);
    SYSCTRL_Lock();

    GPIO_Config_T gpioConfig;
    gpioConfig.pin = GPIO_PIN_4;
    gpioConfig.mode = GPIO_MODE_OUT;
    gpioConfig.speed = GPIO_OS_HIGH;
    gpioConfig.type = GPIO_OT_PP;
    gpioConfig.pullEn = ENABLE;
    gpioConfig.polarity = GPIO_POL_UP;
    gpioConfig.drive = GPIO_DS_HIGH;
    GPIO_Config(&gpioConfig);
    GPIO_ResetBit(GPIO_PIN_4);
}

/*!
 * @brief   WWDT irq handler
 *
 * @param   None
 *
 * @retval  None
 */
void WWDT_IRQ_Handler(void)
{
    if (WWDT_ReadIntFlag() != 0)
    {
        WWDT_ClearIntFlag();
        if (feeddogTime++ <= 5)
        {
            WWDT_FeedDog();
        }
    }
}
